unit piSysdata;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, DBTables;

const
  piAbout='(C) 2000, Programmed Integration';
  piVersion='1.00';

type
  TpiAbout = String[32];
  TpiVersion = String[4];

  TpiSysdata = class(TTable)
  private
    { Private declarations }
    FAbout: TpiAbout;
    FVersion: TpiVersion;
    procedure SetAbout(const Value: TpiAbout);
    procedure SetVersion(const Value: TpiVersion);
  protected
    { Protected declarations }
  public
    { Public declarations }
    function NextId(UseField:String):LongInt;
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
  published
    { Published declarations }
    property About: TpiAbout read FAbout write SetAbout;
    property Version: TpiVersion read FVersion write SetVersion;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PI Components', [TpiSysData]);
end;

function TpiSysdata.NextId(UseField:String):LongInt;
var
  	ExceptionMessage: string;
  	forcount1: Integer;
begin
  	Result:=-1;
  	if not Active then
   	Open;
  	First;
  	if FindField(UseField)=Nil then
  		begin
     		ExceptionMessage:='Field '+UseField+' not found in table '+TableName+'.';
     		Result:=-1;
  		end
  	else
   	begin
     		for forcount1:=0 to 10 do
         	begin
       			try
         			edit;
         			result:=fieldbyname(UseField).AsInteger+1;
         			fieldbyname(UseField).asinteger:=Result;
         			post;
         			break;
       			Except
         			on E:EDatabaseError do
            			ExceptionMessage:=E.Message;
       			End;
     			end;
      end;
	if Result=-1 then
   	MessageDlg(ExceptionMessage, mtWarning, [mbOk], 0);
end;

constructor TpiSysdata.Create(AOwner: TComponent);
begin
   inherited Create(AOwner);
   FAbout:=piAbout;
   FVersion:=piVersion;
end;

destructor TpiSysdata.Destroy;
begin
   inherited Destroy;
end;

procedure TpiSysdata.SetVersion(const Value: TpiVersion);
begin
  FVersion:=FVersion;
end;

procedure TpiSysdata.SetAbout(const Value: TpiAbout);
begin
  FAbout:=FAbout;
end;

end.
